-- yadafrac : yet another fractal exploration program, as a GtkAda training
--
-- Written by Thierry Bernier, see http://thiberlog.free.fr/
-- this source code is released to the public domain.
--
-- $Id: gadtal.ads,v 1.5 2005/02/25 18:08:15 Grands Exp $



with Glib;                use Glib;
with Gdk.Pixmap;          use Gdk.Pixmap;
with Gdk.GC;              use Gdk.GC;
with Gtk.Window;          use Gtk.Window;
with Gtk.Drawing_Area;    use Gtk.Drawing_Area;
with Gtk.Adjustment;      use Gtk.Adjustment;
with Gtk.Toggle_Button;   use Gtk.Toggle_Button;
with Gtk.Check_Button;    use Gtk.Check_Button;

with Number;
with Surface;

package Gadtal is

--type Gadtal_Record is new Gtk_Drawing_Area_Record with private;
  type Gadtal_Record is new Gtk_Window_Record with private;
  type Gadtal_Type is access all Gadtal_Record'Class;


  subtype Value_Type is Surface.Color_Type;
  type Fmap_Type is access function (C : Number.Complex; D : Value_Type)
                                     return Value_Type;

  type Calc_Type is record
    Rect : Number.Rect;
  end record;


  procedure Gtk_New (Gadtal : out Gadtal_Type);

  procedure Set_Calc (Gadtal : in Gadtal_Type;
                      Rect   : in Number.Rect;
                      Fmap   : in Fmap_Type);


private

  task type Evaluator_Task (Owner : access Gadtal_Record) is
    entry Start;
    entry Done;
  end;

  type Evaluator_Ref is access Evaluator_Task;

  type Rect_Selector_Type is record
    Selecting      : Boolean;
    X1, Y1, X2, Y2 : Gint;
  end record;

  -- Devrait etre limited, mais RM95-3.4(15)
  type Gadtal_Record is new Gtk_Window_Record with record
    Area          : Gtk_Drawing_Area;
    Store         : Gdk_Pixmap;
    GC            : Gdk_GC;
    Adj_Depth     : Gtk_Adjustment;
    AutoZoom      : Gtk_Toggle_Button;
    Alive         : Gtk_Check_Button;
    Going_Up      : Boolean;
    Width, Height : Gint;
    Evaluator     : Evaluator_Ref;
    Halt          : Boolean;
    Rect_Selector : Rect_Selector_Type;
    Domain        : Number.Rect;
  end record;

end Gadtal;


