-- yadafrac : yet another fractal exploration program, as a GtkAda training
--
-- Written by Thierry Bernier, see http://thiberlog.free.fr/
-- this source code is released to the public domain.
--
-- $Id: number.ads,v 1.4 2005/02/25 18:08:16 Grands Exp $

with System;
with Ada.Text_IO,
     Ada.Numerics.Generic_Elementary_Functions,
     Ada.Numerics.Generic_Complex_Types,
     Ada.Numerics.Generic_Complex_Elementary_Functions;

package Number is

--type Real is digits System.Max_Digits;	-- Le zoom marche pas ?
  type Real is digits 15;

  package Real_IO is new Ada.Text_IO.Float_IO (Real);
  package Real_EF is new Ada.Numerics.Generic_Elementary_Functions (Real);
  package Real_CT is new Ada.Numerics.Generic_Complex_Types (Real);
  package Real_CF is new Ada.Numerics.Generic_Complex_Elementary_Functions (
                           Real_CT);

  use Real_IO, Real_EF, Real_CT, Real_CF;

  subtype Complex is Real_CT.Complex;


  type Rect is record
    Min, Max : Complex;
  end record;

end Number;

