-- yadafrac : yet another fractal exploration program, as a GtkAda training
--
-- Written by Thierry Bernier, see http://thiberlog.free.fr/
-- this source code is released to the public domain.
--
-- $Id: surface.ads,v 1.5 2005/02/25 18:03:05 Grands Exp $


with Glib;                  use Glib;
with Gdk.Types;             use Gdk.Types;
with Gdk.Color;             use Gdk.Color;
with Gdk.GC;                use Gdk.GC;
with Gdk.Drawable;          use Gdk.Drawable;

package Surface is

  type Color_Type is range 0 .. 1_000;

  type Colormap_Type is array (Color_Type) of Gdk_Color;

  type Surface_Type is private;

  procedure Reset (S : out Surface_Type;
                   D : in  Gdk_Drawable);

--procedure Reset (S : out Surface_Type;
--                 D : in  Gdk_Drawable;
--                 C : in  Colormap_Type);

  function Width  (S : Surface_Type) return Gint;
  function Height (S : Surface_Type) return Gint;

  procedure Draw_Point (S    : in out Surface_Type;
                        X, Y : in     Gint;
                        C    : in     Color_Type);

  procedure Fill_Rect (S          : in out Surface_Type;
                       Xmin, Ymin : in     Gint;
                       Xmax, Ymax : in     Gint;
                       C          : in     Color_Type);

  procedure Flush (S : in out Surface_Type);


private

  type Points_Type is record
    Count : Natural;
    Pool  : Gdk_Points_Array (1 .. 100);
  end record;

  type Lists_Type is array (Color_Type) of Points_Type;

  type Surface_Type is record
    Drawable : Gdk_Drawable;
    GC       : Gdk_GC;
    Colormap : Colormap_Type;
    Lists    : Lists_Type;
  end record;

end Surface;


